Fatal error: Cannot redeclare 原因与解决方法

今天在用PHP博客程序Wordpress的时候,结果在“后台 - 外观 -小工具”这里,报错如下:

Fatal error: Cannot redeclare hot_comment_viewed() (previously declared in /fujieace/nginxssl/html/wp-content/themes/fujie/inc/function/widget.php:350) in /fujieace/nginxssl/html/wp-content/themes/fujie/inc/function/widget.php on line 350

中文翻译

致命错误:无法重新声明 hot_comment_viewed()(以前在/fujieace/nginxssl/html/wp-content/themes/fujie/inc/function/widget.php:350中声明)

Fatal error: Cannot redeclare

 

原因:

通过上面的翻译,也能大概猜出来了。

字面意思理解的就是:某个方法被重复定义了。

再通俗点讲就是:你连续两次及以上使用相同名称来定义一个函数。例如:

function myFunction(){}

function myFunction(){}

 

如果你的程序代码没什么问题,还发生这个错误,在PHP中一般是由于include、require引起来的,具体知识如下:

include:使用include引用外部文件时,只有代码执行到include代码段时,调用的外部文件才会被引用并读取,当引用的文件发生错误时,系统只会给出个警告错误,而整个php文件会继续执行。

require:在php文件被执行之前,php解析器会用被引用的文件的全部内容替换require语句,然后与require语句之外的其他语句组成个新的php文件,最好后按新的php文件执行程序代码。

 

include和require的区别

使用require语句来调用文件时,如果调用的文件没有找到,require语句会输出错误信息,并且立即终止脚本处理。儿include语句在没有找到文件时则会输出警告,不会终止脚本的处理。

使用require语句调用文件时,只要程序一执行,就会立刻调用外部文件。而通过include语句调用外部文件时,只有程序执行到该代码段时,才会调用外部文件。

 

include_once:使用include_once会在导入文件前先检测该文件是否在该页面的其他部分被应用过,如果有,则不会重复引用该文件,程序只能引用一次。(要导入的文件中存在一些自定义函数,那么如果在同一个程序中重复导入这个文件,在第二次导入时便会发生错误,因为php不允许相同名称的函数被重复声明)

require_once:require_once语句是require语句的延伸,他的功能与require语句基本一致,不同的是,在应用require_once时,先会检查要引用的文件是不是已将在该程序中的其他地方被引用过,如果有,则不会在重复调用该文件。(同事使用require_once语句在同一页面中引用了两个不同的文件,那么在输出时,只有第一个文件被执行,第二个引用的文件则不会被执行)

 

include_once和require_once的区别

include_once语句在脚本执行期间调用外部文件发生错误时,但不会影响程序向下运行。而require_once语句则会出现一个致命的错误,用途都是确保一个被包含的文件只能被包含一次,使用这两个语句可以防止意外的多次包含相同的数据库,从而导致函数的重复定义并产生错误。

 

解决方法

以我这里PHP博客程序Wordpress为例子,由于我是用的Wordpress主题,以前一直是正常的,只是突然出现这个报错了,我解决也很简单,具体如下:

 

既然说 hot_comment_viewed() 这个函数或方法被重复定义了,那我就直接去到 widget.php 350行,把那个方法屏闭掉或者删除。

349 <?php
 350 /**************屏闭开始*********************************************
 351 function hot_comment_viewed($number, $days){
 352     global $wpdb;
 353     $sql = "SELECT ID , post_title , comment_count
 354            FROM $wpdb->posts
 355            WHERE post_type = 'post' AND post_status = 'publish' AND TO_DAYS(now()) - TO_DAYS(post_date) < $days
 356            ORDER BY comment_count DESC LIMIT 0 , $number ";
 357     $posts = $wpdb->get_results($sql);
 358         $i = 1;
 359     $output = "";
 360     foreach ($posts as $post){
 361         $output .= "\n<li><span class='li-icon li-icon-$i'>$i</span><a href= \"".get_permalink($post->ID)."\" rel     =\"bookmark\" title=\" (".$post->comment_count."条评论)\" >".$post->post_title."</a></li>";
 362                 $i++;
 363     }
 364     echo $output;
 365 }
 366 ***************************屏闭结束*********************************/
 367 ?>
 368 <div id="hot_comment_widget">
 369         <ul>
 370                 <?php // hot_comment_viewed($number, $days); ?>
 371                 <?php wp_reset_query(); ?>
 372         </ul>
 373 </div>

 

注意:

370行的代码也得屏闭掉,因为涉及到调用函数,不屏闭照样会报错误。

 

最后我才发现,不是主题代码的问题,是由于我最近更新了Wordpress版本的问题,造成了Wordpress版本和主题不兼容,毕竟我的主题是N年以前的老主题了。

 

现在的Wordpress小工具打开如下图:Wordpress小工具

 

还需要提醒大家一点:

虽然说我屏闭代码能够正常进入Wordpress小工具了。

但是,如果你以后不解除屏闭的代码,你网站上但凡是调用此代码的内容是不会再显示出来的。

 

因此,我为了保证网站的布局不影响,我成功进小工具后修改了相关的设置后,我保存后,我出来又重新把屏闭掉的代码恢复了,这样网站整个都正常了。

 

最后还要说一下,由于我更新到新版本的Worpdress后,小工具虽然可以进去了,但是发现修改某些设置后并不能保存内容了,也是主题和Wordpress版本不兼容引起的,这个大家要注意一下。

    A+
发布日期:2023年03月22日 19:13:17  所属分类:PHP
最后更新时间:2023-03-23 10:06:35
付杰
  • ¥ 159.0元
  • 市场价:499.0元
  • ¥ 99.0元
  • 市场价:129.0元
  • ¥ 499.0元
  • 市场价:499.0元
  • ¥ 798.0元
  • 市场价:1298.0元

发表评论

:?: :razz: :sad: :evil: :!: :smile: :oops: :grin: :eek: :shock: :???: :cool: :lol: :mad: :twisted: :roll: :wink: :idea: :arrow: :neutral: :cry: :mrgreen: